#!/usr/bin/perl

$| = 1;

use strict;
use warnings;
use lib qw(lib pm);

use Aranea::Shell;
use Data::Dumper;

my $USAGE = "usage: $0 [modules-file] [questions-file]\n";

my $modules_file = shift or die $USAGE;
my $file = shift or die $USAGE;

print "Starting Aranea...\n";
print "modules list = <$modules_file>\n";
print "question file = <$file>\n";

open(FILE, "< $modules_file");
my @modules_list = <FILE>;
close(FILE);

my $modules;

foreach my $t ( @modules_list ) {
    chop $t;
    # ignore empty lines and 
    next if $t =~ /^#/ or $t =~ /^\s*$/;
    push @$modules, $t;
}

my $shell = Aranea::Shell->new(MODULES => $modules);
$shell->load_modules();

my $tag = ($file =~ /\/([^\/]+)$/ ? $1 : $file);

open(FILE, "< $file");
print `date`;

while ( <FILE> ) {
    /([^\t]+)\t([^\n]+)/;
    my ($query, $qno) = ($2, $1);

    print "\nQuestion $qno: $query\n";
    my $args = [$query, $qno];

    $shell->ARGS($args);

    my $Aranea = $shell->execute();

    $Aranea->write_xml("playground/$tag.$qno");
}

print `date`;
close(FILE);
