#!/usr/bin/perl -w
#< Boilerplate
#
# The Aranea question answering system
# Copyright (C) 2002-2005, Jimmy Lin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, please visit
# http://www.gnu.org/copyleft/gpl.html
#
# $Header: /fs/clip-qa/.cvsroot//Aranea/pm/Aranea/Modules/CreateObject.pm,v 1.17 2005/06/10 16:17:16 jimmylin Exp $
#
#>
#< POD
###############################################################################

=head1 NAME

B<C<Aranea::Modules::CreateObject>> - Aranea module for creating an
Aranea XML object

=head1 SYNOPSIS

This Aranea modules is meant to be used in conjunction with the
L<C<Aranea::Shell>|Aranea::Shell>.

=head1 DESCRIPTION

This Aranea module is used to create and instantiate an Aranea XML
object, i.e., as the first module in a pipeline.  Unlike a standard
C<doModule> method that takes an
L<C<Aranea::XML::Aranea>|Aranea::XML::Aranea> object as the sole
argument, the C<doModule> method of this module takes two scalar
arguments: the question and the question id.  From this information,
the module creates a new (empty) Aranea XML object.

=cut

###############################################################################
#>
#< Header
package Aranea::Modules::CreateObject;

use strict;
use warnings;

use IO::Handle;

use Aranea::XML::Aranea;
use Aranea::Common qw(:default);

#>

#< STDIN handler
unless ( caller() ) {
    my $qid = '';
    $qid = shift;
    $qid = 'stdin' unless $qid;

    while ( <STDIN> ) {
	chop;
	my $Aranea = doModule($_, $qid);
	$Aranea->write_xml();
    }
}
#>

#< sub doModule
sub doModule {
    my ($q, $qid) = @_;

    my $Aranea = Aranea::XML::Aranea->new();

    $Aranea->insert_pipeline_tag('$Id: CreateObject.pm,v 1.17 2005/06/10 16:17:16 jimmylin Exp $ ');

    # save the original query and id
    $Aranea->query()->original($q);
    $Aranea->query()->id($qid);

    return $Aranea;
}
#>

1;
