#!/usr/bin/perl -w
#< Boilerplate
#
# The Aranea question answering system
# Copyright (C) 2002-2005, Jimmy Lin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, please visit
# http://www.gnu.org/copyleft/gpl.html
#
# $Header: /fs/clip-qa/.cvsroot//Aranea/pm/Aranea/Resources/Infoplease.pm,v 1.6 2005/06/09 11:46:51 jimmylin Exp $
#
#>
#< Header
package Aranea::Resources::Infoplease;

use strict;
use warnings;

use vars qw(%DATA);

#>

#< BEGIN
BEGIN {
    my $path = "pm/Aranea/Resources";
    
    open(FILE, "< $path/Infoplease.area-population") or 
	die "Infoplease datafile not found!\n";

    while ( <FILE> ) {
	chop;
	my ($country, $area, $population) = split("\t", $_, 3);
	$DATA{$country}{'area'} = $area;
	$DATA{$country}{'population'} = $population;
    }
    close(FILE);

    open(FILE, "< $path/Infoplease.currency") or 
	die "Infoplease datafile not found!\n";

    while ( <FILE> ) {
	chop;
	my ($country, $currency) = split("\t", $_, 2);
	$DATA{$country}{'currency'} = $currency;
    }
    close(FILE);

    open(FILE, "< $path/Infoplease.capital") or 
	die "Infoplease datafile not found!\n";

    while ( <FILE> ) {
	chop;
	my ($country, $capital) = split("\t", $_, 2);
	$DATA{$country}{'capital'} = $capital;
    }
    close(FILE);
}
#>

#< STDIN handler
unless ( caller() ) {
    while ( <STDIN> ) {
	chop;
	my @args = split("\t", $_);
	my @results = get(@args);
	map { print "$_\n"; } @results;
    }
}
#>

#< sub get
sub get {
    my $country = shift;
    my $att = shift;

    $country = normalize_country($country);

    my @results = ();

    push @results, $DATA{$country}{$att} if exists($DATA{$country}{$att});

    return @results;
}
#>

#< normalize_country
sub normalize_country {
    my $country = shift;

    $country = 'Bahamas, The' if $country eq 'Bahamas';
    $country = 'Gambia, The' if $country eq 'Gambia';
    $country = 'Netherlands, The' if $country eq 'Netherlands';
    $country = 'Philippines, The' if $country eq 'Philippines';

    $country = 'Congo, Republic of the' if $country eq 'Congo';
    $country = 'Congo, Democratic Republic of the' if $country eq 'Zaire';
    $country = 'Yugoslavia' if $country =~ /(Serbia|Montenegro)/;
    $country = 'Bosnia and Herzegovina' if $country =~ /(Bosnia|Herzegovina)/;
    $country = 'Micronesia, Federated States of' if $country eq 'Micronesia';

    $country = 'Korea, North' if $country eq 'North Korea';
    $country = 'Korea, South' if $country eq 'South Korea';

    $country = 'Guinea-Bissau' if $country eq 'Guinea Bissau';
    $country = 'Myanmar' if $country eq 'Burma';

    $country = 'Vatican City' if $country eq 'Holy See';

    $country = 'United States' if $country eq 'United States of America';
    $country = 'United States' if $country =~ /U\.?S\.?(A\.?)?/;
    $country = 'United Kingdom' if $country =~ /(Great )?Britain/;
    $country = 'United Arab Emirates' if $country eq 'U\.?A\.?E\.?';

    $country =~ s/Santa/Saint/g;

    return $country;
}
#>

1;
