#!/usr/bin/perl -w
#< Boilerplate
#
# The Aranea question answering system
# Copyright (C) 2002-2005, Jimmy Lin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, please visit
# http://www.gnu.org/copyleft/gpl.html
#
# $Header: /fs/clip-qa/.cvsroot//Aranea/pm/Aranea/Resources/WebElements.pm,v 1.2 2005/06/09 11:46:51 jimmylin Exp $
#
#>
#< Header
package Aranea::Resources::WebElements;

use strict;
use warnings;

our %DATA;
our $WEBELEMENTS;

#>

#< BEGIN
BEGIN {
    # load the 50states data from a tab separated data file
    my $path = "pm/Aranea/Resources";

    open(FILE, "< $path/WebElements-data.txt") 
	or die "WebElements datafile not found!\n";

    # read the first line, which is the field definition
    my $s = <FILE>;
    chop $s;
    my @fields = split("\t", $s);

    # read tab separated line for every state
    while ( <FILE> ) {
	chop;
	my @cells = split("\t", $_);
	my $state = $cells[0];
	#print "=>$state\n";
	for my $i ( 1 .. $#cells ) {
	    #print "##$fields[$i]: $cells[$i]\n";
	    $DATA{$state}{$fields[$i]} = $cells[$i];
	}
	#print "$_\n";
    }
    close(FILE);

    $WEBELEMENTS = '(actinium|aluminum|americium|antimony|argon|arsenic|astatine|barium|berkelium|beryllium|bismuth|bohrium|boron|bromine|cadmium|caesium|calcium|californium|carbon|cerium|caesium|chlorine|chromium|cobalt|copper|curium|dubnium|dysprosium|einsteinium|erbium|europium|fermium|fluorine|francium|gadolinium|gallium|germanium|gold|hafnium|hassium|helium|holmium|hydrogen|indium|iodine|iridium|iron|krypton|lanthanum|lawrencium|lead|lithium|lutetium|magnesium|manganese|meitnerium|mendelevium|mercury|molybdenum|neodymium|neon|neptunium|nickel|niobium|nitrogen|nobelium|osmium|oxygen|palladium|phosphorus|platinum|plutonium|polonium|potassium|praseodymium|promethium|protactinium|radium|radon|rhenium|rhodium|rubidium|ruthenium|rutherfordium|samarium|scandium|seaborgium|selenium|silicon|silver|sodium|strontium|sulphur|sulphur|tantalum|technetium|tellurium|terbium|thallium|thorium|thulium|tin|titanium|tungsten|ununbium|ununhexium|ununnilium|ununoctium|ununquadium|unununium|uranium|vanadium|xenon|ytterbium|yttrium|zinc|zirconium|Ac|Al|Am|Sb|Ar|As|At|Ba|Bk|Be|Bi|Bh|B|Br|Cd|Cs|Ca|Cf|C|Ce|Cs|Cl|Cr|Co|Cu|Cm|Db|Dy|Es|Er|Eu|Fm|F|Fr|Gd|Ga|Ge|Au|Hf|Hs|He|Ho|H|In|I|Ir|Fe|Kr|La|Lr|Pb|Li|Lu|Mg|Mn|Mt|Md|Hg|Mo|Nd|Ne|Np|Ni|Nb|N|No|Os|O|Pd|P|Pt|Pu|Po|K|Pr|Pm|Pa|Ra|Rn|Re|Rh|Rb|Ru|Rf|Sm|Sc|Sg|Se|Si|Ag|Na|Sr|S|S|Ta|Tc|Te|Tb|Tl|Th|Tm|Sn|Ti|W|Uub|Uuh|Uun|Uuo|Uuq|Uuu|U|V|Xe|Yb|Y|Zn|Zr)';

}
#>

#< STDIN handler
unless ( caller() ) {
    while ( <STDIN> ) {
	chop;
	my @args = split("\t", $_);
	my @results = get(@args);
	map { print "$_\n"; } @results;
    }
}
#>

#< sub get
sub get {
    my $entity = shift;
    my $property = shift;

    my @results = ();
    if ( $property and exists $DATA{$entity}{$property} ) {
	push @results, $DATA{$entity}{$property};
    }
    elsif ( $property and exists $DATA{lc($entity)}{$property} ) {
	push @results, $DATA{lc($entity)}{$property};
    }

    return @results;
}
#>

1;
